// Datei: rc5tst2.c
// RC5 Infrarot Empfnger und Anzeige am COM Port
// alternativ RC5 Infrarot Empfnger fr WinAmp
//
// Wartet bis irgendein RC5 Code empfangen wurde und
// gibt ToggleBit,Gertecode und Kommandocode
// als ASCII auf der seriellen Schnittstelle aus.
// Bevor Daten bertragen werden mu im Terminalfenster
// "rc" (klein ! und kein Enter) eingegeben werden. Der Empfnger
// antwortet dann mit OK. Danach wartet er auf IR-Signale.
//
// Ausgabeformat: Tx Axx Cxx
// T=  Togglebit 0 oder 1
// A= zwei Stellen Gertecode dezimal
// C= drei Stellen Kommandocode dezimal
//
// Das Gert kann auch als RC5 Fernbedienungsempfnger fr
// Winamp verwendet werden !! Besonderheiten dabei: Das Togglebit
// wird ignoriert. Der Gertecode kann ignoriert werden ! Damit arbeitet
// der Empfnger mit z.B. CD-Player ODER Videorecorder Fernbedienung.
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 25.09.2001
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor
#include "rc5tst2.h"
#include "protos.h"

#include "delay.c"
#include "phase.c"
#include "serial.c"
#include "bin2bcd8.c"
 
unsigned char shift;   //Register fr die Abtastung
unsigned char subcode; //Der RC5 Gertecode
unsigned char comcode; //Der RC5 Kommandocode
unsigned char toggle;  //Das Togglebit
unsigned char combuf;  //Puffer fr Verify
unsigned char subbuf;
unsigned char togbuf;
unsigned char mode;   //RC5-Tester oder Winamp Plugin

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char by,by1;
 
// OSCCAL=W; //Als erstes den Kalibrierwert fr den int. RC-Oszi sichern

 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

 TRIS=0b111001;  //0=Ausgang, 1=Eingang
 GPIO=0b111001;  //Port einmal schreiben
 
 TX=0;

 Delay1ms(50); //Warten auf PowerUp
 
//Das Winamp-Plugin sendet "IR" um zu sehen ob der Empfnger da ist 
//Der Empfnger antwortet mit "OK". Ohne CR,LF am Ende !
//Alternativ kann auch "rc" gesendet werden. Dann geht der Empfnger
//in den RC5-Tester Modus

 mode=TESTER; //Grundeinstellung RC5-Tester

//Falls "IR" oder "rc" falsch empfangen wurde nochmal versuchen
repser:
 by=Receive();
 if(by!='I' && by!='r') goto repser; //War kein 'I' oder 'r'. Dann nochmal versuchen

 by=Receive();
 if(by!='R' && by!='c') goto repser; //War kein 'R' oder 'c'. Dann nochmal versuchen

 if(by=='R') mode=WINAMP; //"IR" empfangen, dann Winamp Modus

 Transmit('O'); //Antwort senden
 Transmit('K');
 if(mode==TESTER) { Transmit(0x0d); Transmit(0x0a); } //neue Zeile fr Terminal

 while(1) // Programm-Endlosschleife
  {

   OPTION=0b11000010; //Prescaler 1:8 fr PhaseDemod !

   do
    {
     by=PhaseDemod(); //Warten auf RC5 Code
    }while(by==0);    //Bis by>0

   combuf=comcode; //Eben empfangenen Code speichern
   subbuf=subcode;
   togbuf=toggle;

   do //Code ein zweites mal empfangen. Vermeidet Fehlcodes
    {
     by=PhaseDemod(); //Warten auf RC5 Code
    }while(by==0);    //Bis by>0


   if(comcode==combuf && subcode==subbuf && toggle==togbuf) //Beide Codes gleich ?
    {
     PULS_OFF(); //LED aus
     
     OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

     if(mode==WINAMP)
      {
//##########################################################################################
//Die Zeile hier drunter aktivieren um den Gertecode zu ignorieren !
//       subcode=20; //Gertekennung ignorieren. Immer als CD Player empfangen
//##########################################################################################
       Transmit(subcode);
       Transmit(comcode);
       Transmit(0); //Auffllen auf sechs Bytes
       Transmit(0);
       Transmit(0);
       Transmit(0);
      } 
     else //Tester Modus
      {
       Transmit('T');
       if(toggle==ONE) toggle='1'; //Eine 1
       else            toggle='0'; //Eine 0
       Transmit(toggle); //Togglebit senden
       Transmit(' ');

       Transmit('A');
       B0=subcode; BinToBCD8(); //subcode in BCD umrechnen
       ShowBCD(R1);             //Zwei ASCII-Bytes senden
       Transmit(' ');

       Transmit('C');
       B0=comcode; BinToBCD8(); //comcode in BCD umrechnen
       R0+=0x30;
       Transmit(R0);
       ShowBCD(R1);             //Zwei ASCII-Bytes senden

       Transmit(0x0d); //Neue Zeile
       Transmit(0x0a);
      } 

     Delay1ms(100); //zu hufiges empfangen vermeiden
     
    } //if(comcode==combuf && subcode==subbuf && toggle==togbuf)
   
  } //while(1) Endlosschleife

}
